/* This file is part of epsilon, a functional language implementation

epsilon v0.01
Copyright (C) Luca Saiu, 2002

This is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This software is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this file; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

%{

void fill_buffer_with_yytext(char* buffer,char* yytext);

void output_string(char*);

%}

CHAR        .
NEWLINE     \\n
TAB         \\t
BEEP        \\a
DOUBLEQUOTE \\\"
OTHERESCAPE \\.

%%

{CHAR}        {output_string(yytext);}
{NEWLINE}     {output_string("\n");}
{TAB}         {output_string("\t");}
{BEEP}        {output_string("\a");}
{DOUBLEQUOTE} {output_string("\"");}
{OTHERESCAPE} {output_string(yytext+1);}

%%

char *string_buffer;
void output_string(char *s){
  strcpy(string_buffer,s);
  string_buffer+=strlen(s);
}

void fill_buffer_with_yytext(char* buffer,char* text){
  YY_BUFFER_STATE bufferState=yy_scan_string(text);

  string_buffer=buffer;
  yylex();
  yy_delete_buffer(bufferState);
}

int strings_wrap(){
  return 1;
}

