/* This file is part of epsilon, a functional language implementation

epsilon v0.01
Copyright (C) Luca Saiu, 2002

This is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This software is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this file; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#ifndef SYMBOLSTABLE_H_
#define SYMBOLSTABLE_H_

/* This is used to implement a string -> int map */
struct symbols_table;

/* Initialize and destroy the dynamic part of the structure: */
struct symbols_table* st_create();
void st_destroy(struct symbols_table *s);

/* Inserts a (name,value) pair if not already present; if the element
   is already present then update the value: */
int st_insert_next(struct symbols_table *s, const char *name);
int st_insert(struct symbols_table *s, const char *name, int value);

/* We don't need a deletion operator. */

/* Search the table for the name; returns -1 on failure: */
int st_lookup(const struct symbols_table *s, const char *name);

#endif /* #ifndef SYMBOLSTABLE_H_ */



