/* This file is part of epsilon, a functional language implementation

epsilon v0.01
Copyright (C) Luca Saiu, 2002

This is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This software is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this file; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#ifndef _ENVIRONMENT_H_
#define _ENVIRONMENT_H_

#include "types.h"

#define IDENTIFIER_LENGTH 1000

typedef int environment_id;

void init_environment();
void destroy_environment();

environment_id bind(environment_id e,const char* identifier,int n,type_t type);
environment_id bind_with_precedence(environment_id e,const char* identifier,int n,type_t type,int precedence);

void push_environment(environment_id e);
environment_id top_environment();
environment_id previous_environment();
environment_id pop_environment();

int next_free_position(environment_id e);

int lookup(char* identifier,int *jumps_no, int *pos, type_t *t); /* returns 0 iff succeeds */
int lookup_with_precedence(char* identifier,int *jumps_no, int *pos, type_t *t, int *precedence); /* returns 0 iff succeeds */

void create_bindings_stack();
void destroy_bindings_stack();

void push_bindings();
void pop_bindings();
int* current_bindings();

void dump_environment();

#endif /* #ifndef _ENVIRONMENT_H_ */

