/* This file is part of epsilon, a functional language implementation

epsilon v0.01
Copyright (C) Luca Saiu, 2002

This is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This software is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this file; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#ifndef _MULTIBUFFER_H_
#define _MULTIBUFFER_H_

#include <stdio.h>

typedef int buffer_t;

void init_multibuffer();
void free_multibuffer();

buffer_t new_buffer();
void write_to_buffer(buffer_t buffer, const char* string);
void flush_multibuffer();

void push_buffer(buffer_t x);
buffer_t top_buffer();
buffer_t pop_buffer();

#endif /* #ifndef _MULTIBUFFER_H_ */

