/* This file is part of epsilon, a functional language implementation

epsilon v0.01
Copyright (C) Luca Saiu, 2002

This is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This software is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this file; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#ifndef _TERM_H_
#define _TERM_H_

#include <stdio.h>

typedef int constructor_t;

typedef int variable_t;

typedef int term_t;
extern term_t error;

void init_terms();
void free_terms();

constructor_t constructor(char* name,int ariety);
variable_t variable(char* name);
term_t term(constructor_t c, ...);
term_t vterm(variable_t v);

term_t subterm(term_t t,int n);

term_t unify(term_t m, term_t n);

int are_terms_equal(term_t m,term_t n);
int are_terms_equal_excluding_variables(term_t m,term_t n); // Not implemented yet

int is_term_more_general_than(term_t m,term_t n);

void output_term(FILE* f,term_t t);

#endif /* #ifndef _TERM_H_ */

