/* This file is part of epsilon, a functional language implementation

epsilon v0.01
Copyright (C) Luca Saiu, 2002

This is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This software is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this file; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#ifndef LVM_H_
#define LVM_H_

/*
   Every subprogram accesses its n-th parameter (starting from #0 in
   N parameters) as -2 - N + n, relative to the frame pointer
*/

//#define OUTPUT_PINS_NUMBER

#define BLOCK_SIZE 524288

//#define DEBUG

/* Uncomment the following line if you want to trace the stack status while executing: */
//#define TRACE

//#define CHECK_MALLOC

#define DYNAMIC_STACK
#define STACK_OVERFLOW_CHECK  /* not meaningful if DYNAMIC_STACK is defined */

/* This includes bound-checkings in accesses to arrays and strings, and tests on division by zero
   and tests on nullity of arguments of car, cdr, rplaca and rplacd. */
#define RUNTIME_SANITY_CHECKS

#define STACK_RESIZE_LOG

struct LVM;

#endif //#ifndef LVM_H_

